
public class EditDistance_backtracing {

	public static int recursion_steps = 0;

	public static void main(String[] args) {
		if (args.length == 2) {
			String x = (String) args[0];
			String y = (String) args[1];
			computeEditDistanceIterative(x, y);
		}
	}

	// Edit-Distanz wird iterativ berechnet
	public static int computeEditDistanceIterative(String x, String y) {
		char[][] backtracingMatrix = new char[x.length() + 1][y.length() + 1];
		int[][] editMatrix = new int[x.length() + 1][y.length() + 1];
		// Initialisierung vertikal
		for (int i = 0; i < editMatrix.length; i++) {
			editMatrix[i][0] = i;
			backtracingMatrix[i][0] = 'd';
		}
		// Initialisierung horizontal
		for (int i = 0; i < editMatrix[0].length; i++) {
			editMatrix[0][i] = i;
			backtracingMatrix[0][i] = 'i';
		}
		// Berechnung der anderen Eintraege
		for (int i = 1; i < editMatrix.length; i++) {
			for (int j = 1; j < editMatrix[i].length; j++) {
				int copy_sub = editMatrix[i - 1][j - 1];
				if (x.charAt(i - 1) != y.charAt(j - 1)) {
					copy_sub++;
				}
				int insert = editMatrix[i][j-1] + 1;
				int delete = editMatrix[i-1][j] + 1;
				editMatrix[i][j] = returnMinimum(copy_sub, insert, delete);
				backtracingMatrix[i][j] = returnOperation(x, y, i, j, copy_sub,
						insert, delete);
			}
		}
		// Ausgabe der Matrix:
		System.out.println("Die Edit-Matrix: ");
		System.out.print("  - ");
		for (int i = 0; i < y.length(); i++) {
			System.out.print(y.charAt(i) + " ");
		}
		System.out.println();
		for (int i = 0; i < editMatrix.length; i++) {
			if (i == 0) {
				System.out.print("- ");
			} else {
				System.out.print(x.charAt(i - 1) + " ");
			}
			for (int j = 0; j < editMatrix[i].length; j++) {
				System.out.print(editMatrix[i][j] + " ");
			}
			System.out.println();
		}
		System.out.println("Edit-Distanz: "
				+ editMatrix[x.length()][y.length()]);
		//Berechnung eines optimalen Pfades
		int i = x.length();
		int j = y.length();
		String s = "";
		while (!(i == 0 && j == 0)) {
			switch (backtracingMatrix[i][j]) {
			case 'c': {
				i--;
				j--;
				s = 'c' + s;
			}break;
			case 's': {
				i--;
				j--;
				s =  's' + s;
			}break;
			case 'i': {
				j--;
				s =  'i' + s;
			}break;
			case 'd': {
				i--;
				s =  'd' + s;
			}break;
			default:
				System.out.println("Falscher Operator in Backtracing Matrix");
			}
		}
		System.out.println("Eine  optimale Editsequenz lautet: " + s.toUpperCase());
		return editMatrix[x.length()][y.length()];
	}



	// Berechnet das Minimum dreier Zahlen
	public static int returnMinimum(int a, int b, int c) {
		if (a <= b && a <= c) {
			return a;
		}
		if (b <= a && b <= c) {
			return b;
		}
		return c;
	}

	// Berechnet, welche Operation benutzt wurde (nur eine Moeglichkeit)
	public static char returnOperation(String x, String y, int i, int j,
			int copy_sub, int insert, int delete) {
		if (copy_sub <= insert && copy_sub <= delete) {
			if (x.charAt(i - 1) == y.charAt(j - 1)) {
				return 'c';
			} else {
				return 's';
			}
		}
		if (insert <= copy_sub && insert <= delete) {
			return 'i';
		}
		return 'd';
	}
}
